/**********************************************************************
  AhXϊ
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"

int	adtr_func( struct MACHINE_RESOURCE *mres , int *pa, unsigned int ea )
{

int          f0,f1,f2,f3;
unsigned int p0,p1,p2,p3;
 
  f0=0;f1=0;f2=0;f3=0;
  p0=0;p1=0;p2=0;p3=0;

  if( ea==0x8000ff00 ){ // for pseudo IO
    *pa=ea ;
    return(NORMAL_EXIT) ;
  }
  
  if( ( __memfetch_mode==0 && (*mres->MSR & 0x00000010)!=0 ) || ( __memfetch_mode!=0 && (*mres->MSR & 0x00000020)!=0 ) ){

    /** Check BAT adrs translation **/

    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[536-__memfetch_mode] & 0x00000002)!=0) || 
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[536-__memfetch_mode] & 0x00000001)!=0) ){
      if( (*mres->SPR[536-__memfetch_mode] & 0xf0000000)==((ea) & 0xf0000000) && 
          (*mres->SPR[536-__memfetch_mode] & 0x0ffe0000 & ~((*mres->SPR[536-__memfetch_mode] & 0x00001ffc) << 15))
          ==((ea) & 0x0ffe0000 & ~((*mres->SPR[536-__memfetch_mode] & 0x00001ffc) << 15)) ){
        p0=(*mres->SPR[537-__memfetch_mode] & 0xfffe0000 & ~((*mres->SPR[536-__memfetch_mode] & 0x00001ffc) << 15)) 
          | ( (ea) & ((*mres->SPR[536-__memfetch_mode] & 0x00001ffc) << 15)) | ( (ea) & 0x0001ffff) ;
        f0=1 ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[538-__memfetch_mode] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[538-__memfetch_mode] & 0x00000001)!=0) ){
      if( (*mres->SPR[538-__memfetch_mode] & 0xf0000000)==((ea) & 0xf0000000) &&
          (*mres->SPR[538-__memfetch_mode] & 0x0ffe0000 & ~((*mres->SPR[538-__memfetch_mode] & 0x00001ffc) << 15))
          ==((ea) & 0x0ffe0000 & ~((*mres->SPR[538-__memfetch_mode] & 0x00001ffc) << 15)) ){
        p1=(*mres->SPR[539-__memfetch_mode] & 0xfffe0000 & ~((*mres->SPR[538-__memfetch_mode] & 0x00001ffc) << 15)) 
          | ( (ea) & ((*mres->SPR[538-__memfetch_mode] & 0x00001ffc) << 15)) | ( (ea) & 0x0001ffff) ;
        f1=1 ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[540-__memfetch_mode] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[540-__memfetch_mode] & 0x00000001)!=0) ){
      if( (*mres->SPR[540-__memfetch_mode] & 0xf0000000)==((ea) & 0xf0000000) &&
          (*mres->SPR[540-__memfetch_mode] & 0x0ffe0000 & ~((*mres->SPR[540-__memfetch_mode] & 0x00001ffc) << 15))
          ==((ea) & 0x0ffe0000 & ~((*mres->SPR[540-__memfetch_mode] & 0x00001ffc) << 15)) ){
        p2=(*mres->SPR[541-__memfetch_mode] & 0xfffe0000 & ~((*mres->SPR[540-__memfetch_mode] & 0x00001ffc) << 15)) 
          | ( (ea) & ((*mres->SPR[540-__memfetch_mode] & 0x00001ffc) << 15)) | ( (ea) & 0x0001ffff) ;
        f2=1 ;
      }
    }
    if( (( *mres->MSR & 0x00004000 )==0 && (*mres->SPR[542-__memfetch_mode] & 0x00000002)!=0) ||
        (( *mres->MSR & 0x00004000 )!=0 && (*mres->SPR[542-__memfetch_mode] & 0x00000001)!=0) ){
      if( (*mres->SPR[542-__memfetch_mode] & 0xf0000000)==((ea) & 0xf0000000) &&
          (*mres->SPR[542-__memfetch_mode] & 0x0ffe0000 & ~((*mres->SPR[542-__memfetch_mode] & 0x00001ffc) << 15))
          ==((ea) & 0x0ffe0000 & ~((*mres->SPR[542-__memfetch_mode] & 0x00001ffc) << 15)) ){
        p3=(*mres->SPR[543-__memfetch_mode] & 0xfffe0000 & ~((*mres->SPR[542-__memfetch_mode] & 0x00001ffc) << 15)) 
          | ( (ea) & ((*mres->SPR[542-__memfetch_mode] & 0x00001ffc) << 15)) | ( (ea) & 0x0001ffff) ;
        f3=1 ;
      }
    }
    if(      f0==1 ){ *pa=p0 ; return(NORMAL_EXIT) ;}
    else if( f1==1 ){ *pa=p1 ; return(NORMAL_EXIT) ;}
    else if( f2==1 ){ *pa=p2 ; return(NORMAL_EXIT) ;}
    else if( f3==1 ){ *pa=p3 ; return(NORMAL_EXIT) ;}

    /*** Check page adrs translation **/
    {
      unsigned int byte_offset ;
      unsigned int vsid ;
      unsigned int page_index ;
      unsigned int htaborg ;
      unsigned int htabmask ;
      unsigned int hashval1 ;
      unsigned int hashval2 ;
      unsigned int primPTEad ;
      unsigned int secondPTEad ;
      unsigned int pte_u ;
      unsigned int pte_l ;
      int i ;

      byte_offset = ea & 0x00000fff ;
      vsid = *mres->SR[((ea & 0xf0000000)>>28)] & 0x00ffffffff ;
      page_index  = (ea & 0x0ffff000)>>12 ;
      htaborg  = (*mres->SPR[25] & 0xffff0000)>>16 ;
      htabmask = (*mres->SPR[25] & 0x000001ff) ;
      hashval1    = htaborg ^ page_index ;
      primPTEad   = ((htaborg & ~(htabmask))<<16) | ((hashval1 & htabmask)<<16) | ((hashval1 & 0x000003ff)<<6) ;
      hashval2    = ~(hashval1) ;
      secondPTEad = ((htaborg & ~(htabmask))<<16) | ((hashval2 & htabmask)<<16) | ((hashval2 & 0x000003ff)<<6) ;

      /*** primary hash PTE search ***/
      if( mres->mem[seg(primPTEad)]==NULL ) return(NON_PHYMEM) ;
      for( i=0 ; i<8 ; i++ ){
	pte_u = mres->mem[seg(primPTEad+0+i*8)][lad(primPTEad+0+i*8)]<<24 | \
	        mres->mem[seg(primPTEad+1+i*8)][lad(primPTEad+1+i*8)]<<16 | \
                mres->mem[seg(primPTEad+2+i*8)][lad(primPTEad+2+i*8)]<<8  | \
	        mres->mem[seg(primPTEad+3+i*8)][lad(primPTEad+3+i*8)] ;
	if( (pte_u & 0x80000040)==0x80000000 && \
	    ((pte_u & 0x7fff8000)>>15)==vsid && \
	    ((pte_u & 0x0000003f) == (page_index >> 10)) ) {
	  pte_l = mres->mem[seg(primPTEad+4+i*8)][lad(primPTEad+4+i*8)]<<24 | \
	          mres->mem[seg(primPTEad+5+i*8)][lad(primPTEad+5+i*8)]<<16 | \
	          mres->mem[seg(primPTEad+6+i*8)][lad(primPTEad+6+i*8)]<<8  | \
	          mres->mem[seg(primPTEad+7+i*8)][lad(primPTEad+7+i*8)] ;
	  *pa = (pte_l & 0xfffff000) | byte_offset ;
	  fprintf(simmsgfp,"ea=%08x   pa=%08x\n",ea,*pa) ;
	  return(NORMAL_EXIT) ;
	}
      }
      /*** secondary hash PTE search ***/
      if( mres->mem[seg(secondPTEad)]==NULL ) return(NON_PHYMEM) ;
      for( i=0 ; i<8 ; i++ ){
	pte_u = mres->mem[seg(secondPTEad+0+i*8)][lad(secondPTEad+0+i*8)]<<24 | \
	        mres->mem[seg(secondPTEad+1+i*8)][lad(secondPTEad+1+i*8)]<<16 | \
                mres->mem[seg(secondPTEad+2+i*8)][lad(secondPTEad+2+i*8)]<<8  | \
	        mres->mem[seg(secondPTEad+3+i*8)][lad(secondPTEad+3+i*8)] ;
	if( (pte_u & 0x80000040)==0x80000000 && \
	    ((pte_u & 0x7fff8000)>>15)==vsid && \
	    ((pte_u & 0x0000003f) == (page_index >> 10)) ) {
	  pte_l = mres->mem[seg(secondPTEad+4+i*8)][lad(secondPTEad+4+i*8)]<<24 | \
	          mres->mem[seg(secondPTEad+5+i*8)][lad(secondPTEad+5+i*8)]<<16 | \
	          mres->mem[seg(secondPTEad+6+i*8)][lad(secondPTEad+6+i*8)]<<8  | \
	          mres->mem[seg(secondPTEad+7+i*8)][lad(secondPTEad+7+i*8)] ;
	  *pa = (pte_l & 0xfffff000) | byte_offset ;
	  fprintf(simmsgfp,"ea=%08x   pa=%08x\n",ea,*pa) ;
	  return(NORMAL_EXIT) ;
	}
      }
    }
    return(MEM_AREA_OVER) ;    
  }else{
    *pa=ea ;
    return(NORMAL_EXIT) ;
  }
}

