/**********************************************************************
  ߎs ̂P
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int op_exec2( struct MACHINE_RESOURCE *mres ) ;
int op_exec3( struct MACHINE_RESOURCE *mres ) ;
int op_exec4( struct MACHINE_RESOURCE *mres ) ;
int op_exec5( struct MACHINE_RESOURCE *mres ) ;
int op_scemu( struct MACHINE_RESOURCE *mres ) ;

int	op_exec1( struct MACHINE_RESOURCE *mres )
{
register unsigned int op1 ;
register unsigned int inst ;
int             adrs_update ;
unsigned int	r1,r2,cr,d,ea ;
unsigned int	bi,bo,ab,lk,adrs ;
int             simm ;
unsigned int	uimm ;
unsigned int	rd ;

 inst=mres->inst ;
 op1 =inst & 0xfc000000 ;
 
 if( op1==0x7c000000 ){ //RegToReg Operation
   return( op_exec2( mres ) ) ;
 }
 if( op1==0x4c000000 ){ //RegSource Operation
   return( op_exec3( mres ) ) ;
 }
 if( op1==0xfc000000 ){ //Floating Double Operation
   return( op_exec4( mres ) ) ;
 }
 if( op1==0xec000000 ){ //Floating Single Operation
   return( op_exec5( mres ) ) ;
 }
 
 if( op1==0x48000000 ){ //b,ba,bl,bla
   adrs=inst & 0x03fffffc ;
   ab  =inst & 0x00000002 ;
   lk  =inst & 0x00000001 ;
   if( lk!=0 ) mres->FLGR.lrl=mres->pc+4 ;
   if( ab==0 ){
     if( (adrs & 0x02000000)!=0 ){
       adrs = adrs | 0xfc000000 ; //g
     }
     mres->pc += adrs ;
   }else{
     mres->pc = adrs ;
   }
   return(0) ;
 }
 
 if( op1==0x40000000 ){ //bc,bca,bcl,bcla
   int	cc ;
   int	branch ;
   branch = NO ;
   adrs= inst & 0x0000fffc ;
   ab  = inst & 0x00000002 ;
   lk  = inst & 0x00000001 ;
   bo  =(inst & 0x03e00000)<<6  ;
   bi  =(inst & 0x001f0000)>>16 ;
   cc  = mres->FLGR.cr[(bi/4)] & (0x80000000>>(bi%4)) ;
   switch( (bo & 0xf0000000) ){
   case 0x00000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 && cc==0 ) branch=YES ;
     break ;
   case 0x10000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 && cc==0 ) branch=YES ;
     break ;
   case 0x20000000 :
     if( cc==0 ) branch=YES ;
     break ;
   case 0x40000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 && cc!=0 ) branch=YES ;
     break ;
   case 0x50000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 && cc!=0 ) branch=YES ;
     break ;
   case 0x60000000 :
     if( cc!=0 ) branch=YES ;
     break ;
   case 0x80000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 ) branch=YES ;
     break ;
   case 0x90000000 :
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 ) branch=YES ;
     break ;
   case 0xa0000000 :
     branch=YES ;
     break ;
   default :
     return(INVALID_BO) ;
   }
   if( branch==YES ){
     if( lk!=0 ) mres->FLGR.lrl=mres->pc+4 ;
     if( ab==0 ){
       if( (adrs & 0x00008000)!=0 ){
	 adrs = adrs | 0xffff0000 ; //g
       }
       mres->pc += adrs ;
     }else{
       mres->pc = adrs ;
     }
   }else{
     mres->pc += 4 ;
   }
   return(0) ;
 }
 
 if( (op1 & 0xc0000000)==0x80000000 ){ //lbz,lbzu,lhz,lhzu,lha,lhau,lwz,lwzu
   
   r1= (inst & 0x03e00000)>>21 ;
   r2= (inst & 0x001f0000)>>16 ;
   adrs_update = inst & 0x04000000 ; //AhXXV[h
   d = (inst & 0x0000ffff) ;
   if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g

   if( (inst & 0xbc000000)==0xb8000000 ){ // lmw
     int i ;
     if( r2==0 ){
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     for( i=r1 ; i<32 ; i++ ){
       fetchu4b(mres->GPR[i].rl,ea) ;
       ea+=4 ;
     }
     mres->pc+=4 ;
     return(0) ;
   }

   if( (inst & 0xbc000000)==0xbc000000 ){  // stmw
     int i ;
     if( r2==0 ){
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     for( i=r1 ; i<32 ; i++ ){
       storeu4b(mres->GPR[i].rl,ea) ;
       ea+=4 ;
     }
     mres->pc+=4 ;
     return(0) ;
   }
     
   if( (inst & 0x10000000)==0 ){	//load ANZX
     if( r2==0 ){
       if( adrs_update!=0 ){
	 return( INSTFORM_IS_INVALID ) ;
       }
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     switch( (inst & 0x28000000) ){
     case 0x00000000 : //lwz,lwzu
       fetchu4b(mres->GPR[r1].rl,ea) ;
       break ;
     case 0x08000000 : //lbz,lbzu
       fetchu1b(mres->GPR[r1].rl,ea) ;
       break ;
     case 0x20000000 : //lhz,lhzu
       fetchu2b(mres->GPR[r1].rl,ea) ;
       break ;
     case 0x28000000 : //lha,lhau
       fetchs2b(mres->GPR[r1].rl,ea) ;
       break ;
     default : 
       return(UNKNOWN_INSTRUCTION) ;
     }
     if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
     
   }else{ //stb,stbu,sth,sthu,stw,stwu
     if( r2==0 ){ //rA==0
       if( adrs_update!=0 ){
	 return( INSTFORM_IS_INVALID ) ;
       }
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     switch( (inst & 0x28000000) ){
     case 0x00000000 : //stw,stwu
       storeu4b(mres->GPR[r1].rl,ea) ;
       break ;
     case 0x08000000 : //stb,stbu
       storeu1b(mres->GPR[r1].rl,ea) ;
       break ;
     case 0x20000000 : //sth,sthu
       storeu2b(mres->GPR[r1].rl,ea) ;
       break ;
     default : 
       return(UNKNOWN_INSTRUCTION) ;
     }
     if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xc0000000)==0xc0000000 ){ //lfs,lfsu,lfd,lfdu
   
   //		fprintf(simmsgfp,"mres->pc=%08x : exec1_lfx\n",mres->pc) ;
   r1= (inst & 0x03e00000)>>21 ;
   r2= (inst & 0x001f0000)>>16 ;
   adrs_update = inst & 0x04000000 ; //AhXXV[h
   d = (inst & 0x0000ffff) ;
   if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
   
   if( (inst & 0x10000000)==0 ){	//load ANZX
     if( r2==0 ){
       if( adrs_update!=0 ){
	 return( INSTFORM_IS_INVALID ) ;
       }
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     switch( (inst & 0x28000000) ){
     case 0x00000000 : //lfs,lfsu
       fetchf4b(mres->FPR[r1].f,ea) ;
       break ;
     case 0x08000000 : //lfd,lfdu
       fetchd8b(mres->FPR[r1].f,ea) ;
       break ;
     default : 
       return(UNKNOWN_INSTRUCTION) ;
     }
     if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
     
   }else{							//stfs,stfsu,stfd,stfdu
     if( r2==0 ){	//rA==0
       if( adrs_update!=0 ){
	 return( INSTFORM_IS_INVALID ) ;
       }
       ea = d ;
     }else{
       ea = mres->GPR[r2].rl+d ;
     }
     switch( (inst & 0x28000000) ){
       float float_tmp ;
     case 0x00000000 : //stfs,stfsu
       float_tmp = mres->FPR[r1].f ;
       storef4b(mres->FPR[r1].f,ea) ;
       break ;
     case 0x08000000 : //stfd,stfdu
       stored8b(mres->FPR[r1].f,ea) ;
       break ;
     default : 
       return(UNKNOWN_INSTRUCTION) ;
     }
     if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xf0000000)==0x30000000 ){ //addi,addis,addic,addic.
   unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
   
   r1= (inst & 0x03e00000)>>21 ;
   r2= (inst & 0x001f0000)>>16 ;
   simm = (inst & 0x0000ffff) ;
   if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g
   switch( op1 & 0x0c000000 ){
   case 0x08000000 : //addi
     rd=simm ;
     if( r2!=0 ) rd=mres->GPR[r2].rl+rd ;
     mres->GPR[r1].rl=rd ;
     break ;
   case 0x0c000000 : //addis
     rd=simm<<16 ;
     if( r2!=0 ) rd=mres->GPR[r2].rl+rd ;
     mres->GPR[r1].rl=rd ;
     break ;
   case 0x00000000 : //addic
     bit32c=((mres->GPR[r2].rl & 0x00000001)+
	     (simm & 0x00000001))>>1 ;
     tmpui1=mres->GPR[r2].rl>>1 ;
     tmpui2=((unsigned int)simm)>>1 ;
     tmpui0=tmpui1+tmpui2+bit32c ;
     //	fprintf(simmsgfp,"%08x : tmpui0=%x g2=%x,simm=%x,bit32c=%x\n",
     //	mres->pc,tmpui0,mres->GPR[r2].rl,simm,bit32c) ;
     if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
     else                         mres->FLGR.xer &=~0x20000000 ;
     mres->GPR[r1].rl=mres->GPR[r2].rl+simm ;
     break ;
   case 0x04000000 : //addic.
     bit32c=((mres->GPR[r2].rl & 0x00000001)+
	     (simm & 0x00000001))>>1 ;
     tmpui1=mres->GPR[r2].rl>>1 ;
     tmpui2=((unsigned int)simm)>>1 ;
     tmpui0=tmpui1+tmpui2+bit32c ;
     if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
     else                         mres->FLGR.xer &=~0x20000000 ;
     mres->GPR[r1].rl=mres->GPR[r2].rl+simm ;
     update_cr( mres->GPR[r1].rl ) ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xf0000000)==0x10000000 ){ //mulli
   r1= (inst & 0x03e00000)>>21 ;
   r2= (inst & 0x001f0000)>>16 ;
   simm = (inst & 0x0000ffff) ;
   if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g
   mres->GPR[r1].rl=mres->GPR[r2].rl*simm ;
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xf0000000)==0x20000000 ){ //subfic, cmpi, cmpli
   unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
   
   r1= (inst & 0x03e00000)>>21 ;
   r2= (inst & 0x001f0000)>>16 ;
   cr= (inst & 0x03800000)>>23 ;
   simm = (inst & 0x0000ffff) ;
   uimm = simm ;
   if( (simm & 0x00008000)!=0 ) simm=simm | 0xffff0000 ; //g
   switch( op1 & 0x0c000000 ){
   case 0x00000000 : //subfic
     bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	     (simm & 0x00000001)+1)>>1 ;
     tmpui1=~mres->GPR[r2].rl>>1 ;
     tmpui2=((unsigned int)simm)>>1 ;
     tmpui0=tmpui1+tmpui2+bit32c ;
     // fprintf(simmsgfp,"%08x : tmpui0=%x g2=%x,simm=%x,bit32c=%x\n",
     //         mres->pc,tmpui0,~mres->GPR[r2].rl,simm,bit32c) ;
     if( (tmpui0&0x80000000)!=0 ) mres->FLGR.xer |= 0x20000000 ;
     else                         mres->FLGR.xer &=~0x20000000 ;
     mres->GPR[r1].rl= -mres->GPR[r2].rl + simm ;
     break ;
   case 0x0c000000 : //cmpi
     // fprintf(simmsgfp,"mres->pc=0x%08x    cr_No=%d   cr=%08x\n",mres->pc,cr,mres->FLGR.cr[cr]) ;
     if( (int)mres->GPR[r2].rl==simm ) mres->FLGR.cr[cr] |= 0x20000000 ;
     else                        mres->FLGR.cr[cr] &=~0x20000000 ;
     if( (int)mres->GPR[r2].rl> simm ) mres->FLGR.cr[cr] |= 0x40000000 ;
     else                        mres->FLGR.cr[cr] &=~0x40000000 ;
     if( (int)mres->GPR[r2].rl< simm ) mres->FLGR.cr[cr] |= 0x80000000 ;
     else                        mres->FLGR.cr[cr] &=~0x80000000 ;
     if( (mres->FLGR.xer & 0x80000000)!=0 ) mres->FLGR.cr[cr] |= 0x10000000 ;
     else                             mres->FLGR.cr[cr] &=~0x10000000 ;
     // fprintf(simmsgfp,"mres->pc=0x%08x    cr_No=%d   cr=%08x\n",mres->pc,cr,mres->FLGR.cr[cr]) ;
     break ;
   case 0x08000000 : //cmpli
     if( mres->GPR[r2].rl==uimm ) mres->FLGR.cr[cr] |= 0x20000000 ;
     else                   mres->FLGR.cr[cr] &=~0x20000000 ;
     if( mres->GPR[r2].rl> uimm ) mres->FLGR.cr[cr] |= 0x40000000 ;
     else                   mres->FLGR.cr[cr] &=~0x40000000 ;
     if( mres->GPR[r2].rl< uimm ) mres->FLGR.cr[cr] |= 0x80000000 ;
     else                   mres->FLGR.cr[cr] &=~0x80000000 ;
     if( (mres->FLGR.xer & 0x80000000)!=0 ) mres->FLGR.cr[cr] |= 0x10000000 ;
     else                             mres->FLGR.cr[cr] &=~0x10000000 ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xf8000000)==0x70000000 ||
     (op1 & 0xf0000000)==0x60000000 ){ //andi.,andis.,ori,oris,xori,xoris
   
   r1= (inst & 0x03e00000)>>21 ; //rS
   r2= (inst & 0x001f0000)>>16 ; //rA
   uimm = (inst & 0x0000ffff) ;
   switch( (op1 & 0x1c000000) ){
   case 0x10000000 : //andi.
     mres->GPR[r2].rl = mres->GPR[r1].rl & uimm ;
     update_cr( mres->GPR[r2].rl ) ;
     break ;
   case 0x14000000 : //andis.
     mres->GPR[r2].rl = mres->GPR[r1].rl & (uimm<<16) ;
     update_cr( mres->GPR[r2].rl ) ;
     break ;
   case 0x00000000 : //ori
     mres->GPR[r2].rl = mres->GPR[r1].rl | uimm ;
     break ;
   case 0x04000000 : //oris
     mres->GPR[r2].rl = mres->GPR[r1].rl | (uimm<<16) ;
     break ;
   case 0x08000000 : //xori
     mres->GPR[r2].rl = mres->GPR[r1].rl ^ uimm ;
     break ;
   case 0x0c000000 : //xoris
     mres->GPR[r2].rl = mres->GPR[r1].rl ^ (uimm<<16) ;
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( (op1 & 0xf0000000)==0x50000000 ){ //rlwinm,rlwnm,rlwnm.,rlwnimi,rlwnimi.
   int	sh,mb,me,updt_cr ;
   int	bitmask_num ;
   unsigned int	bitmask,masktmp ;
   unsigned int	shiftin ; //[e[gœĂrbg
   int	i ;
   
   r1= (inst & 0x03e00000)>>21 ; //rS
   r2= (inst & 0x001f0000)>>16 ; //rA
   sh= (inst & 0x0000f800)>>11 ; //SH or rB
   mb= (inst & 0x000007c0)>>6  ; //MB
   me= (inst & 0x0000003e)>>1  ; //ME
   updt_cr= (inst & 0x00000001)  ; //update_cr
   if( me<mb ){
     /** MBME傫ꍇ́AWX^bitwrapă}XN𐶐B **/
     bitmask_num=mb-me-1 ;
     masktmp=0x80000000>>((me+1)%32) ;
     for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
       bitmask |= masktmp ;
     }
     bitmask = ~bitmask ;
     // fprintf(simmsgfp,"mb=%d,me=%d,mask=%08x\n",mb,me,bitmask) ;
   }else{
     bitmask_num=me-mb+1 ;
     masktmp=0x80000000>>mb ;
     for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
       bitmask |= masktmp ;
     }
   }
   
   switch( op1 & 0x0c000000 ){
   case 0x04000000 : //rlwinm, rlwinm.(CRXVĂH)
     shiftin=mres->GPR[r1].rl>>(32-sh) ;
     mres->GPR[r2].rl = ((mres->GPR[r1].rl<<sh) | shiftin) & bitmask ;
     if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
     break ;
   case 0x0c000000 : //rlwnm,rlwnm.
		     // mres->GPR[sh].rl̉6bit炵 32bitCvgł5bit̂ƓH
     shiftin=mres->GPR[r1].rl>>(32-(mres->GPR[sh].rl & 0x0000001f)) ;
     mres->GPR[r2].rl = ((mres->GPR[r1].rl<<(mres->GPR[sh].rl & 0x0000001f)) | shiftin) & bitmask ;
     if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
     break ;
   case 0x00000000 : //rlwimi,rlwimi.
     shiftin=mres->GPR[r1].rl>>(32-sh) ;
     mres->GPR[r2].rl = mres->GPR[r2].rl & ~bitmask ; // (1)Zbg
     mres->GPR[r2].rl = mres->GPR[r2].rl | (((mres->GPR[r1].rl<<sh) | shiftin) & bitmask) ; //(2)Zbg
     if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
 }
 
 if( inst==0x44000002 ){ //sc
   if( excp_stat.e0c00.stat == DISABLE ){
     return( op_scemu( mres ) ) ;
   }
   return(EXCEPTION_SYSCALL) ;
 }
 
 return(UNKNOWN_INSTRUCTION) ;
}
