/**********************************************************************
  VXeR[G~[V
   for newlib based Standard C library
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"
#include <time.h>
#include <sys/time.h>

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres ) ;
void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void set_DIR_entry( unsigned int adrs , DIR *dirpt ) ;
void remove_DIR_entry( unsigned int adrs ) ;
DIR* search_DIR_entry( unsigned int adrs ) ;
void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;

int	op_scemu( struct MACHINE_RESOURCE *mres )
{
static int top_fd=0 ;
int	   ret ;

 if( truss_stat==ON ) fprintf(simmsgfp,"%08x:Syscall_NO=%d\n  ",mres->pc,mres->GPR[0].rl) ;
 switch( mres->GPR[0].rl ){
   int mode1,mode2 ;
   int size ;
 case 1: // exit()
   if( truss_stat==ON ) fprintf(simmsgfp,"exit(%x)\n",mres->GPR[3].rl) ;
   return(SYSCALLED_EXIT) ;
 case 2: // fork()
   mres->pc+=4 ;
   return(SYSCALLED_FORK) ;
 case 3 : // read()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"Read_fd=%d+%d 0x%08x,0x%08x\n",
	     mres->GPR[3].rl,top_fd,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = read( (int)mres->GPR[3].rl+top_fd,
	       &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
	       (unsigned int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 4 : // write()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"Write_fd=%d+%d 0x%08x,0x%08x\n",
	     mres->GPR[3].rl,top_fd,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = write( (int)mres->GPR[3].rl+top_fd,
		&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
		(unsigned int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 5: // open()
   open_mode_exchg( &mode1 , &mode2 , mres ) ;
   if( truss_stat==ON ){
     fprintf(simmsgfp,"Opened_Name=%s,0x%x,0x%x\n",&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mode1,mode2) ;
   }
   ret = open( &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], mode1, mode2) ;
   if( truss_stat==ON ) fprintf(simmsgfp,"  >>Opend_fd=%d+%d\n",ret,top_fd) ;
   mres->GPR[3].rl = ret - top_fd ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 6: // close()
   if( truss_stat==ON ) fprintf(simmsgfp,"Close_fd=%d+%d\n",mres->GPR[3].rl,top_fd) ;
   if( mres->GPR[3].rl>=0 && mres->GPR[3].rl<5 ){
     /** WION[YȂlɂ **/
     if( truss_stat==ON ){
       fprintf(simmsgfp,"Close_fd is STDIO. close() exec is blocked by close() emulator.\n") ;
     }
     ret=0 ;
   }else{
     ret = close( (int)mres->GPR[3].rl+top_fd ) ;
   }
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 10: // unlink()
   if( truss_stat==ON ) fprintf(simmsgfp,"unlink not implement yet.\n") ;
   mres->GPR[3].rl = 0 ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 11: // execve()
   if( truss_stat==ON ) fprintf(simmsgfp,"execve\n") ;
   mres->pc+=4 ;
   return(SYSCALLED_EXECVE) ;
 case 12: // chdir()
   if( truss_stat==ON ) fprintf(simmsgfp,"chdir( %s )\n",(char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
   ret = chdir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 13: // time()
   if( truss_stat==ON ) fprintf(simmsgfp,"time( 0x%x )\n",mres->GPR[3].rl) ;
   ret = time( (time_t *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 15: // chmod()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"chmod( %s , 0x%x )\n",
	     (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	     mres->GPR[4].rl ) ;
   }
   ret = chmod( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 19: // lseek()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"lseek_fd=%d+%d 0x%08x,0x%08x\n",
	     mres->GPR[3].rl,top_fd, mres->GPR[4].rl,mres->GPR[5].rl ) ;
   }
   ret = lseek( (int)mres->GPR[3].rl+top_fd,
		(off_t)mres->GPR[4].rl,
		(int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 30: // utime()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"utime( %s , 0x%x )\n",
	     (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	     mres->GPR[4].rl ) ;
   }
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   ret = utime( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(struct utimbuf *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 43: // times()
   if( truss_stat==ON ) fprintf(simmsgfp,"times( 0x%08x ).\n",(int)mres->GPR[3].rl) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   ret = times( (struct tm *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 54: // ioctl()
   if( truss_stat==ON ) fprintf(simmsgfp,"ioctl is not implement yet.\n") ;
   mres->pc+=4 ; return(UNKNOWN_SYSCALL_NO) ;
 case 55: // fcntl()
   if( truss_stat==ON ) fprintf(simmsgfp,"fcntl_fl=%d+%d\n",mres->GPR[3].rl,top_fd) ;
   ret = fcntl( (int)mres->GPR[3].rl+top_fd,
		(int)mres->GPR[4].rl,
		(int)mres->GPR[5].rl,
		(int)mres->GPR[6].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 78: // gettimeofday()
   if( truss_stat==ON ) fprintf(simmsgfp,"gettimeofday( 0x%08x , 0x%08x ).\n",
				(int)mres->GPR[3].rl,(int)mres->GPR[4].rl) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   ret = gettimeofday( (struct timeval  *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		       (struct timezone *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 89: // readdir()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"readdir(0x%x).\n", mres->GPR[3].rl ) ;
   }
   {
     struct dirent *dp ;
     DIR_exchg( mres, mres->GPR[3].rl ) ;
     dp = readdir( (DIR *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
     DIR_exchg( mres, mres->GPR[3].rl ) ;
     if( dp==NULL ) mres->GPR[3].rl=0 ;
     else{
       mres->GPR[3].rl=mres->GPR[4].rl ; /** dpԂ **/
       dirent_exchg( mres, mres->GPR[4].rl ) ;
       memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dp, sizeof(struct dirent) ) ;
       dirent_exchg( mres, mres->GPR[4].rl ) ;
     }
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 205: // _opendir()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"opendir(0x%x,0x%x).\n", mres->GPR[3].rl, mres->GPR[4].rl ) ;
   }
   {
     DIR *dirp ;

     DIR_exchg( mres, mres->GPR[4].rl ) ;
     dirp = opendir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
     if( dirp==NULL ) mres->GPR[3].rl=0 ;
     else{
       set_DIR_entry( mres->GPR[4].rl , dirp ) ;
       mres->GPR[3].rl=mres->GPR[4].rl ; /** PPCdirpԂ **/
       memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dirp, sizeof(DIR) ) ;
     }
     DIR_exchg( mres, mres->GPR[4].rl ) ;
     /*CygwinŃt@CGg(dirent̃Xg)ێĂ炵̂
       dirpV~[^ɕێĂAclosedir()͎sĂ͂ȂȂ*/
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 206: // closedir()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"closedir(0x%x).\n", mres->GPR[3].rl ) ;
   }
   {
     DIR *dirp ;
     dirp=search_DIR_entry( mres->GPR[3].rl ) ;
     if( dirp==NULL ){
       fprintf(simmsgfp,"closedir() emulator internal error?.\n") ;
     }
     ret = closedir( dirp ) ;
     //fprintf(simmsgfp,"closedir ret = %x.\n", ret ) ;
     remove_DIR_entry( mres->GPR[3].rl ) ;
     mres->GPR[3].rl = ret ;
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 106: // stat()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"stat(%s,0x%x)\n",&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mres->GPR[4].rl) ;
   }
   stat_exchg( mres, mres->GPR[4].rl ) ;
   ret = stat( &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	       (struct stat *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   stat_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   if( truss_stat==ON ) fprintf(simmsgfp,"stat_ret=0x%x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 107: // lstat()
   if( truss_stat==ON ) fprintf(simmsgfp,"lstat(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   stat_exchg( mres, mres->GPR[4].rl ) ;
   ret = lstat( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
   		(struct stat *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   stat_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 108: // fstat()
   if( truss_stat==ON ) fprintf(simmsgfp,"fstat(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   stat_exchg( mres, mres->GPR[4].rl ) ;
   ret = fstat( (int)mres->GPR[3].rl+top_fd,
		(struct stat *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   stat_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 181: // chown()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"chown( %s , 0x%x , 0x%x )\n",
	     (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	     mres->GPR[4].rl,
	     mres->GPR[5].rl ) ;
   }
   ret = chown( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(uid_t)mres->GPR[4].rl,
		(gid_t)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 182: // getcwd()
   if( truss_stat==ON ) fprintf(simmsgfp,"getcwd(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   ret = getcwd( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		 (int)mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 200: // isatty()
   if( truss_stat==ON ) fprintf(simmsgfp,"isatty(%d)\n",mres->GPR[3].rl) ;
   ret = isatty( (int)mres->GPR[3].rl+top_fd ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 202: // sbrk()
   if( truss_stat==ON ) fprintf(simmsgfp,"sbrk=(0x%08x)\n",mres->GPR[3].rl) ;
   size=(int)mres->GPR[3].rl ;
   //if( (size%4)!=0 ) size=((size/4)+1)*4 ; // alignment 4byte boundary
   //   fprintf(simmsgfp,"htap_top=%x heap_size=%x mem_size=%x size=%x.\n",
   //   	mres->heap_top,mres->heap_size,mres->mem_size,size) ;
   if( ((mres->heap_top+mres->heap_size+size) >= mres->mem_size[0x0]) ||
       ((mres->heap_size+size) < 0)  ){
     mres->GPR[3].rl = 0xffffffff ;
     mres->GPR[0].rl = 12 ; /** ENOMEM **/
     //     fprintf(simmsgfp,"sbrk() faild.\n") ;
   }else{
     mres->GPR[3].rl = mres->heap_top+mres->heap_size ;
     mres->heap_size+= size ;
     //     fprintf(simmsgfp,"sbrk() succeed.\n") ;
   }
   mres->pc+=4 ; return(0) ;
 case 203: // pathconf()
   if( truss_stat==ON ){
     fprintf(simmsgfp,"pathconf(0x%x,0x%x)\n",
	     mres->GPR[3].rl,mres->GPR[4].rl) ;
   }
   ret = pathconf( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		   (int)mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 }
 
 return(UNKNOWN_SYSCALL_NO) ;
}

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres )
{
  /*
    open()̃tOւ
  */
  *mode1=mres->GPR[4].rl | 0x10000 ; /*** force binary mode ***/
  //*mode1=mres->GPR[4].rl ;
  *mode2=mres->GPR[5].rl ;
}

void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    stat\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*stat->st_dev*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 1] ; ptr[ 1]=tmp ;
  /*ptr[2],ptr[3]̓E߂̌*/
  /*stat->st_ino*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ; 
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ; 
  /*stat->st_mode*/
  tmp=ptr[ 8] ;ptr[ 8]=ptr[11] ; ptr[11]=tmp ; 
  tmp=ptr[ 9] ;ptr[ 9]=ptr[10] ; ptr[10]=tmp ; 
  /*stat->st_nlink*/
  tmp=ptr[12] ;ptr[12]=ptr[13] ; ptr[13]=tmp ;
  /*stat->st_uid*/
  tmp=ptr[14] ;ptr[14]=ptr[15] ; ptr[15]=tmp ;
  /*stat->st_gid*/
  tmp=ptr[16] ;ptr[16]=ptr[17] ; ptr[17]=tmp ;
  /*stat->st_rdev*/
  tmp=ptr[18] ;ptr[18]=ptr[19] ; ptr[19]=tmp ;
  /*stat->st_size*/
  tmp=ptr[20] ;ptr[20]=ptr[23] ; ptr[23]=tmp ; 
  tmp=ptr[21] ;ptr[21]=ptr[22] ; ptr[22]=tmp ; 
  /*stat->st_atime*/
  tmp=ptr[24] ;ptr[24]=ptr[27] ; ptr[27]=tmp ; 
  tmp=ptr[25] ;ptr[25]=ptr[26] ; ptr[26]=tmp ; 
  /*stat->st_spare1*/
  tmp=ptr[28] ;ptr[28]=ptr[31] ; ptr[31]=tmp ; 
  tmp=ptr[29] ;ptr[29]=ptr[30] ; ptr[30]=tmp ; 
  /*stat->st_mtime*/
  tmp=ptr[32] ;ptr[32]=ptr[35] ; ptr[35]=tmp ; 
  tmp=ptr[33] ;ptr[33]=ptr[34] ; ptr[34]=tmp ; 
  /*stat->st_spare2*/
  tmp=ptr[36] ;ptr[36]=ptr[39] ; ptr[39]=tmp ; 
  tmp=ptr[37] ;ptr[37]=ptr[38] ; ptr[38]=tmp ; 
  /*stat->st_ctime*/
  tmp=ptr[40] ;ptr[40]=ptr[43] ; ptr[43]=tmp ; 
  tmp=ptr[41] ;ptr[41]=ptr[42] ; ptr[42]=tmp ; 
  /*stat->st_spare3*/
  tmp=ptr[44] ;ptr[44]=ptr[47] ; ptr[47]=tmp ; 
  tmp=ptr[45] ;ptr[45]=ptr[46] ; ptr[46]=tmp ; 
  /*stat->st_blksize*/
  tmp=ptr[48] ;ptr[48]=ptr[51] ; ptr[51]=tmp ; 
  tmp=ptr[49] ;ptr[49]=ptr[50] ; ptr[50]=tmp ; 
  /*stat->st_blocks*/
  tmp=ptr[52] ;ptr[52]=ptr[55] ; ptr[55]=tmp ; 
  tmp=ptr[53] ;ptr[53]=ptr[54] ; ptr[54]=tmp ; 
  /*stat->st_spare4[0]*/
  tmp=ptr[56] ;ptr[56]=ptr[59] ; ptr[59]=tmp ; 
  tmp=ptr[57] ;ptr[57]=ptr[58] ; ptr[58]=tmp ; 
  /*stat->st_spare4[1] =*/
  tmp=ptr[60] ;ptr[60]=ptr[63] ; ptr[63]=tmp ; 
  tmp=ptr[61] ;ptr[61]=ptr[62] ; ptr[62]=tmp ; 
}

void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    DIR\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*DIR->__d_cookie*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*DIR->*__d_dirent*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
  /*DIR->*__d_dirname*/
  tmp=ptr[ 8] ;ptr[ 8]=ptr[11] ; ptr[11]=tmp ;
  tmp=ptr[ 9] ;ptr[ 9]=ptr[10] ; ptr[10]=tmp ;
  /*DIR->*__d_position*/
  tmp=ptr[12] ;ptr[12]=ptr[15] ; ptr[15]=tmp ;
  tmp=ptr[13] ;ptr[13]=ptr[14] ; ptr[14]=tmp ;
  /*DIR->__d_dirhash*/
  tmp=ptr[16] ;ptr[16]=ptr[19] ; ptr[19]=tmp ;
  tmp=ptr[17] ;ptr[17]=ptr[18] ; ptr[18]=tmp ;
  /*DIR->__d_u.__d_filler[16]*/
  /*char^zȂ̂ŁAsv*/
}

void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    dirent\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*dirent->__d_reserved[0]*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*dirent->__d_reserved[1]*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
  /*dirent->__d_reserved[2]*/
  tmp=ptr[ 8] ;ptr[ 8]=ptr[11] ; ptr[11]=tmp ;
  tmp=ptr[ 9] ;ptr[ 9]=ptr[10] ; ptr[10]=tmp ;
  /*dirent->__d_reserved[3]*/
  tmp=ptr[12] ;ptr[12]=ptr[15] ; ptr[15]=tmp ;
  tmp=ptr[13] ;ptr[13]=ptr[14] ; ptr[14]=tmp ;
  /*dirent->__d_ino*/
  tmp=ptr[16] ;ptr[16]=ptr[19] ; ptr[19]=tmp ;
  tmp=ptr[17] ;ptr[17]=ptr[18] ; ptr[18]=tmp ;
  /*dirent->__d_u.__d_name[256]*/
  /*char^zȂ̂ŁAsv*/
}

void set_DIR_entry( unsigned int adrs , DIR *dirpt )
{
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==0 ){
     dir_list[i].ppc_mem_ptr=adrs ;
     dir_list[i].cygwin_DIR =dirpt ;
     break ;
   }
 }
}

void remove_DIR_entry( unsigned int adrs )
{
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     dir_list[i].ppc_mem_ptr=0 ;
     dir_list[i].cygwin_DIR =NULL ;
     break ;
   }
 }
}

DIR* search_DIR_entry( unsigned int adrs )
{
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     return(dir_list[i].cygwin_DIR) ;
   }
 }
 return(NULL) ;
}

void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    timbuf\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*timbuf->actime*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*timbuf->modtime*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
}

void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    tm\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*tm->tm_sec*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*tm->tm_min*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
  /*tm->tm_hour*/
  tmp=ptr[ 8] ;ptr[ 8]=ptr[11] ; ptr[11]=tmp ;
  tmp=ptr[ 9] ;ptr[ 9]=ptr[10] ; ptr[10]=tmp ;
  /*tm->tm_mday*/
  tmp=ptr[12] ;ptr[12]=ptr[15] ; ptr[15]=tmp ;
  tmp=ptr[13] ;ptr[13]=ptr[14] ; ptr[14]=tmp ;
  /*tm->tm_mon*/
  tmp=ptr[16] ;ptr[16]=ptr[19] ; ptr[19]=tmp ;
  tmp=ptr[17] ;ptr[17]=ptr[18] ; ptr[18]=tmp ;
  /*tm->tm_year*/
  tmp=ptr[20] ;ptr[20]=ptr[23] ; ptr[23]=tmp ;
  tmp=ptr[21] ;ptr[21]=ptr[22] ; ptr[22]=tmp ;
  /*tm->tm_wday*/
  tmp=ptr[24] ;ptr[24]=ptr[27] ; ptr[27]=tmp ;
  tmp=ptr[25] ;ptr[25]=ptr[26] ; ptr[26]=tmp ;
  /*tm->tm_yday*/
  tmp=ptr[28] ;ptr[28]=ptr[31] ; ptr[31]=tmp ;
  tmp=ptr[29] ;ptr[29]=ptr[30] ; ptr[30]=tmp ;
  /*tm->tm_isdst*/
  tmp=ptr[32] ;ptr[32]=ptr[35] ; ptr[35]=tmp ;
  tmp=ptr[33] ;ptr[33]=ptr[34] ; ptr[34]=tmp ;
}

void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    timeval\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*timeval->tv_sec*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*timevel->tv_usec*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
}

void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  unsigned char tmp ;
  /*
    timezone\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  /*timezone->tz_minuteswest*/
  tmp=ptr[ 0] ;ptr[ 0]=ptr[ 3] ; ptr[ 3]=tmp ;
  tmp=ptr[ 1] ;ptr[ 1]=ptr[ 2] ; ptr[ 2]=tmp ;
  /*timezone->tzdsttime*/
  tmp=ptr[ 4] ;ptr[ 4]=ptr[ 7] ; ptr[ 7]=tmp ;
  tmp=ptr[ 5] ;ptr[ 5]=ptr[ 6] ; ptr[ 6]=tmp ;
}


/*****************************************************************************


  pathconf(),fpathconf()̎ɂāB
  newlibsysvi386ł͂̓VXeR[ƂĎĂB
  Linuxł(glibc琄) _statfs()VXeR[p pathconf
  libcX68kł͌ŒlԂlȃX^uŎB
  ߂lւlȌ`ŎĂB
  Cygwinł_statfs()gȂ̂ŁApathconf(),fpathconf()̓VXeR[
  ƂĒ`KvB

  readlink()
  Linuxł̓VXeR[ƂĒ`ĂB
  CygwinłVXeR[ƂĒ`ĂH
  libcX68kłsymlinkhCogpDOSR[ƂăG~[gB
*****************************************************************************/
