/**********************************************************************
  fork G~[V
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	sim_fork( struct PROCESS_LIST *proc_list )
{
int child_id ;
int parent_id ; 
struct MACHINE_RESOURCE *child_mres ;
struct MACHINE_RESOURCE *parent_mres ;

 parent_id = proc_list->cur_id ;
 proc_list->cur_id++ ;
 child_id  = proc_list->cur_id ;

 proc_list->proc[child_id]=proc_list->proc[parent_id] ;
 child_mres =&proc_list->proc[child_id] ;
 parent_mres=&proc_list->proc[parent_id] ;

 child_mres->SPR[1] = &child_mres->FLGR.xer  ; // XER
 child_mres->SPR[8] = &child_mres->FLGR.lrl  ; // LR
 child_mres->SPR[9] = &child_mres->FLGR.ctrl ; // CTR

 child_mres->mem[0x0]=malloc(child_mres->mem_size[0x0]) ;
 if( child_mres->mem[0x0]==NULL ){
   fprintf(simmsgfp,"sim_fork memoly alloc error(size=%d).\n",
	   child_mres->mem_size[0x0] ) ;
   return(MEM_ALLOC_ERROR) ;
 }
 
 memcpy( child_mres->mem[0x0], parent_mres->mem[0x0], parent_mres->mem_size[0x0] ) ;
 child_mres->id = child_id ;

 return(NORMAL_EXIT) ;
}
