/**********************************************************************
  ȈIOfoCX
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

#define reverse_uint(a)   { *a=((*a<<24)&0xff000000)|((*a<<8)&0x00ff0000)|((*a>>8)&0x0000ff00)|((*a>>24)&0x000000ff); }

int sim_io( struct MACHINE_RESOURCE *mres )
{
int ret_code ;
int cmd ;
int drv ;
int dtrk ; 
int dtop ;
int dlen ;
int i ; 

 ret_code=0 ;
 /** access output only console device **/
 cmd=mres->mem[seg(CONSOLE_OUT_CMD+3)][lad(CONSOLE_OUT_CMD+3)] ;
 if( cmd != 0 ){
   putc(cmd,stdout) ;
   mres->mem[seg(CONSOLE_OUT_CMD+3)][lad(CONSOLE_OUT_CMD+3)]=0 ;
 }

 /** access DISK device **/
 cmd  = mres->mem[seg(DISK_CMD     +3)][lad(DISK_CMD     +3)] ;
 drv  = mres->mem[seg(DISK_DRIVE   +3)][lad(DISK_DRIVE   +3)] ;
 dtrk = (mres->mem[seg(DISK_TRACK   +0)][lad(DISK_TRACK   +0)]<<24) +
        (mres->mem[seg(DISK_TRACK   +1)][lad(DISK_TRACK   +1)]<<16) +
        (mres->mem[seg(DISK_TRACK   +2)][lad(DISK_TRACK   +2)]<< 8) +
         mres->mem[seg(DISK_TRACK   +3)][lad(DISK_TRACK   +3)] ;
 dtop = (mres->mem[seg(DISK_DATA_TOP+0)][lad(DISK_DATA_TOP+0)]<<24) +
        (mres->mem[seg(DISK_DATA_TOP+1)][lad(DISK_DATA_TOP+1)]<<16) +
        (mres->mem[seg(DISK_DATA_TOP+2)][lad(DISK_DATA_TOP+2)]<< 8) +
         mres->mem[seg(DISK_DATA_TOP+3)][lad(DISK_DATA_TOP+3)] ;
 dlen = (mres->mem[seg(DISK_DATA_LEN+0)][lad(DISK_DATA_LEN+0)]<<24) +
        (mres->mem[seg(DISK_DATA_LEN+1)][lad(DISK_DATA_LEN+1)]<<16) +
        (mres->mem[seg(DISK_DATA_LEN+2)][lad(DISK_DATA_LEN+2)]<< 8) +
         mres->mem[seg(DISK_DATA_LEN+3)][lad(DISK_DATA_LEN+3)] ;

 if( cmd != DISK_NOP ){
   mres->mem[seg(DISK_CMD+3)][lad(DISK_CMD+3)]=DISK_NOP ;
   
   if( drv<0 || drv >= SIM_DISK_DRIVE_NUM ){
     mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_FAIL ;
   }else{
     if( sim_disk[drv].mount==VALID ){
       switch( cmd ){
       case DISK_INQ :
	 for( i=0 ; i<DISK_INQ_LEN ; i++ ){
	   unsigned char *p=(unsigned char *)sim_disk[drv].info ;
	   mres->mem[seg(dtop+i)][lad(dtop+i)]=p[i] ;
	 }
	 mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_IDLE ;
	 break ;
       case DISK_WRITE_INQ :
	 for( i=0 ; i<DISK_INQ_LEN ; i++ ){
	   unsigned char *p=(unsigned char *)sim_disk[drv].info ;
	   p[i]=mres->mem[seg(dtop+i)][lad(dtop+i)] ;
	 }
	 mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_IDLE ;
	 break ;
       case DISK_READ :
	 if( (sim_disk[drv].type & DISK_TYPE_EN_READ)==0 ){
	   mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_FAIL ;
	 }else{
	   for( i=0 ; i<dlen ; i++ ){
	     if( (dtrk*sim_disk[drv].tlen+i)>(sim_disk[drv].tnum * sim_disk[drv].tlen) ) break ;
	     mres->mem[seg(dtop+i)][lad(dtop+i)]=sim_disk[drv].buf[dtrk*sim_disk[drv].tlen+i] ;
	   }
	   mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_IDLE ;
	 }
	 break ;
       case DISK_WRITE :
	 if( (sim_disk[drv].type & DISK_TYPE_EN_WRITE)==0 ){
	   mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_FAIL ;
	 }else{
	   for( i=0 ; i<dlen ; i++ ){
	     if( (dtrk*sim_disk[drv].tlen+i)>(sim_disk[drv].tnum * sim_disk[drv].tlen) ) break ;
	     sim_disk[drv].buf[dtrk*sim_disk[drv].tlen+i]=mres->mem[seg(dtop+i)][lad(dtop+i)] ;
	   }
	   mres->mem[seg(DISK_ACK+3)][lad(DISK_ACK+3)]=DISK_ACK_IDLE ;
	 }
	 break ;
       default :
	 fprintf(simmsgfp,"Sim DISK invalid access command. (0x%08x)\n",cmd) ;
	 ret_code=-1 ;
       }
     }
   }
 }
 
 /** access CLOCK device **/
 cmd  = mres->mem[seg(CLOCK_READ_CMD+3)][lad(CLOCK_READ_CMD+3)] ;
 if( cmd != 0 ){
   if( time( (time_t*)&mres->mem[seg(CLOCK_DATA)][lad(CLOCK_DATA)] ) != -1 ){
     ret_code=-1 ;
   }else{
     reverse_uint( (unsigned int*)&mres->mem[seg(CLOCK_DATA+ 0)][lad(CLOCK_DATA+ 0)] ) ;
   }
   mres->mem[seg(CLOCK_READ_CMD+3)][lad(CLOCK_READ_CMD+3)]=0 ;
 }

#ifdef SUPPORT_GRAPHIC_DEVICE
 cmd  = mres->mem[seg(GRAPHIC_VRAM_SYNC+3)][lad(GRAPHIC_VRAM_SYNC+3)] ;
 if( cmd != 0 ){
   int x,y,p,r,g,b ;
   unsigned int ad ;
   COLORREF pix ;
   
   for( y=0 ; y<GRAPHIC_SCREEN_HEIGHT ; y++ ){
     for( x=0,p=0 ; x<GRAPHIC_SCREEN_WIDTH ; x++,p+=GRAPHIC_VRAM_DEPTH ){
       ad=GRAPHIC_VRAM_TOP + GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*y + p ;
       r=mres->mem[seg(ad+0)][lad(ad+1)] ;
       g=mres->mem[seg(ad+1)][lad(ad+2)] ;
       b=mres->mem[seg(ad+2)][lad(ad+3)] ;
       pix=RGB(r,g,b) ;
       DrawPix(gd,x,y,pix) ;
     }
   }
   SendMessage(gd->win,WM_PAINT,0,0) ;
   mres->mem[seg(GRAPHIC_VRAM_SYNC+3)][lad(GRAPHIC_VRAM_SYNC+3)]=0 ;
 }
 
#endif
 
 return( ret_code ) ;
}

int init_sim_io()
{
  int i ;

  for( i=0 ; i<SIM_DISK_DRIVE_NUM ; i++ ){
    sim_disk[i].mount = INVALID ;
    sim_disk[i].type  = 0 ;
    sim_disk[i].tnum  = 0 ;
    sim_disk[i].info  = NULL ;
    sim_disk[i].buf   = NULL ;
  }
  
#ifdef SUPPORT_GRAPHIC_DEVICE
 gd=OpenGdev(GRAPHIC_SCREEN_WIDTH, GRAPHIC_SCREEN_HEIGHT,GRAPHIC_NAME) ;
 if( gd==NULL ){
   fprintf(stderr,"OtBbNfoCX̃I[vɎs܂\n") ;
   exit(-1) ;
 }
 FlushBuffer(gd) ;
#endif

  return( NORMAL_EXIT ) ;
}

#ifdef SUPPORT_GRAPHIC_DEVICE
void actionfunc(int c)
{
    switch (c){
    default:
        return;
    }
}
#endif
